package whatsapp

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"

	"wechat-api/internal/logic/whatsapp"
	"wechat-api/internal/svc"
	"wechat-api/internal/types"
)

// swagger:route post /whatsapp/registerPhoneNumber whatsapp RegisterPhoneNumber
//
// 注册WhatsApp号码
//
// 注册WhatsApp号码
//
// Parameters:
//  + name: body
//    require: true
//    in: body
//    type: registerReq
//
// Responses:
//  200: BaseMsgResp

func RegisterPhoneNumberHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.RegisterReq
		if err := httpx.Parse(r, &req, true); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := whatsapp.NewRegisterPhoneNumberLogic(r.Context(), svcCtx)
		resp, err := l.RegisterPhoneNumber(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
